<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: RotaryEncoder Class Reference</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="class_rotary_encoder-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">RotaryEncoder Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Event-driven rotary encoder class. Events are split into stable and unstable updates to prevent flooding the mqtt channel with many messages while the slider is being set, while allowing for a local display element (i.e. an led) to give real-time feedback.  
 <a href="class_rotary_encoder.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_rotary_encoder_8h_source.html">RotaryEncoder.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6d0692adb7f49c186b60d61c4b5ed594"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#a6d0692adb7f49c186b60d61c4b5ed594">check</a> ()</td></tr>
<tr class="memdesc:a6d0692adb7f49c186b60d61c4b5ed594"><td class="mdescLeft">&#160;</td><td class="mdescRight">Polls the encoders's _inputFlag and detects events. This should be called in the sketch's loop() function.  <a href="class_rotary_encoder.html#a6d0692adb7f49c186b60d61c4b5ed594">More...</a><br /></td></tr>
<tr class="separator:a6d0692adb7f49c186b60d61c4b5ed594"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add03486f3ea45ab300b2735a19f6c632"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#add03486f3ea45ab300b2735a19f6c632">getId</a> ()</td></tr>
<tr class="memdesc:add03486f3ea45ab300b2735a19f6c632"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the encoder id.  <a href="class_rotary_encoder.html#add03486f3ea45ab300b2735a19f6c632">More...</a><br /></td></tr>
<tr class="separator:add03486f3ea45ab300b2735a19f6c632"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a39492fe10475d3251ebad39f8ec17fc8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#a39492fe10475d3251ebad39f8ec17fc8">getPostition</a> ()</td></tr>
<tr class="memdesc:a39492fe10475d3251ebad39f8ec17fc8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the current encoder postion.  <a href="class_rotary_encoder.html#a39492fe10475d3251ebad39f8ec17fc8">More...</a><br /></td></tr>
<tr class="separator:a39492fe10475d3251ebad39f8ec17fc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cc6dcb7afb68e81546966a1ec24d027"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#a7cc6dcb7afb68e81546966a1ec24d027">initInterrupts</a> (void(*function)())</td></tr>
<tr class="memdesc:a7cc6dcb7afb68e81546966a1ec24d027"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the function to be called when a pin interrupt occurs. Ideally this wouldn't be needed and the pin interrupt would just call <a class="el" href="class_rotary_encoder.html#a5e2bc49ea9072d4932612ded0cfcfabf" title="Raises the button&#39;s _inputFlag. This should be wrapped in a function in the global scope and fed into...">RotaryEncoder::tick()</a>, but only static member functions can be used as callbacks for pin interrupts, so a wrapper function has to be written in the global scope and passed back into the button object.  <a href="class_rotary_encoder.html#a7cc6dcb7afb68e81546966a1ec24d027">More...</a><br /></td></tr>
<tr class="separator:a7cc6dcb7afb68e81546966a1ec24d027"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad73cb09b417e3b8c1bea31a00ccae54f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#ad73cb09b417e3b8c1bea31a00ccae54f">RotaryEncoder</a> (int pinA, int pinB, int id=99)</td></tr>
<tr class="memdesc:ad73cb09b417e3b8c1bea31a00ccae54f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="class_rotary_encoder.html#ad73cb09b417e3b8c1bea31a00ccae54f">More...</a><br /></td></tr>
<tr class="separator:ad73cb09b417e3b8c1bea31a00ccae54f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3bd9303422d4287e96ea83c181f3fcd4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#a3bd9303422d4287e96ea83c181f3fcd4">setEventHandler</a> (void(*function)(<a class="el" href="class_rotary_encoder.html">RotaryEncoder</a> *, uint8_t, int))</td></tr>
<tr class="memdesc:a3bd9303422d4287e96ea83c181f3fcd4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the function that is called any time an encoder event is detected. Some example callback functions can be found in the InputNode example.  <a href="class_rotary_encoder.html#a3bd9303422d4287e96ea83c181f3fcd4">More...</a><br /></td></tr>
<tr class="separator:a3bd9303422d4287e96ea83c181f3fcd4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac91df8b97b799e9411cda5eb4ba5de9c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#ac91df8b97b799e9411cda5eb4ba5de9c">setPosition</a> (int value)</td></tr>
<tr class="memdesc:ac91df8b97b799e9411cda5eb4ba5de9c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the encoder postion. Useful for resetting it back to zero for example.  <a href="class_rotary_encoder.html#ac91df8b97b799e9411cda5eb4ba5de9c">More...</a><br /></td></tr>
<tr class="separator:ac91df8b97b799e9411cda5eb4ba5de9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e2bc49ea9072d4932612ded0cfcfabf"><td class="memItemLeft" align="right" valign="top">void ICACHE_RAM_ATTR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#a5e2bc49ea9072d4932612ded0cfcfabf">tick</a> ()</td></tr>
<tr class="memdesc:a5e2bc49ea9072d4932612ded0cfcfabf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Raises the button's _inputFlag. This should be wrapped in a function in the global scope and fed into <a class="el" href="class_rotary_encoder.html#a7cc6dcb7afb68e81546966a1ec24d027" title="Set the function to be called when a pin interrupt occurs. Ideally this wouldn&#39;t be needed and the pi...">RotaryEncoder::initInterrupts()</a>  <a href="class_rotary_encoder.html#a5e2bc49ea9072d4932612ded0cfcfabf">More...</a><br /></td></tr>
<tr class="separator:a5e2bc49ea9072d4932612ded0cfcfabf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a492bcf97569c21fe3b050d5ee05f5240"><td class="memItemLeft" align="right" valign="top">static const uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#a492bcf97569c21fe3b050d5ee05f5240">kEventStableUpdate</a> = 0</td></tr>
<tr class="memdesc:a492bcf97569c21fe3b050d5ee05f5240"><td class="mdescLeft">&#160;</td><td class="mdescRight">Event ID for a stable update (potentiometer has been changed, then been stable longer than <code>_interval</code>).  <a href="class_rotary_encoder.html#a492bcf97569c21fe3b050d5ee05f5240">More...</a><br /></td></tr>
<tr class="separator:a492bcf97569c21fe3b050d5ee05f5240"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acca85bf302bd19eb2357518d6ce53569"><td class="memItemLeft" align="right" valign="top">static const uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_rotary_encoder.html#acca85bf302bd19eb2357518d6ce53569">kEventUnstableUpdate</a> = 1</td></tr>
<tr class="memdesc:acca85bf302bd19eb2357518d6ce53569"><td class="mdescLeft">&#160;</td><td class="mdescRight">Event ID for a stable update (potentiometer has been changed, but not stopped moving yet).  <a href="class_rotary_encoder.html#acca85bf302bd19eb2357518d6ce53569">More...</a><br /></td></tr>
<tr class="separator:acca85bf302bd19eb2357518d6ce53569"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Event-driven rotary encoder class. Events are split into stable and unstable updates to prevent flooding the mqtt channel with many messages while the slider is being set, while allowing for a local display element (i.e. an led) to give real-time feedback. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad73cb09b417e3b8c1bea31a00ccae54f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad73cb09b417e3b8c1bea31a00ccae54f">&#9670;&nbsp;</a></span>RotaryEncoder()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">RotaryEncoder::RotaryEncoder </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>pinA</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>pinB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>id</em> = <code>99</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Class constructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6d0692adb7f49c186b60d61c4b5ed594"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d0692adb7f49c186b60d61c4b5ed594">&#9670;&nbsp;</a></span>check()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void RotaryEncoder::check </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Polls the encoders's _inputFlag and detects events. This should be called in the sketch's loop() function. </p>

</div>
</div>
<a id="add03486f3ea45ab300b2735a19f6c632"></a>
<h2 class="memtitle"><span class="permalink"><a href="#add03486f3ea45ab300b2735a19f6c632">&#9670;&nbsp;</a></span>getId()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int RotaryEncoder::getId </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the encoder id. </p>

</div>
</div>
<a id="a39492fe10475d3251ebad39f8ec17fc8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a39492fe10475d3251ebad39f8ec17fc8">&#9670;&nbsp;</a></span>getPostition()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int RotaryEncoder::getPostition </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the current encoder postion. </p>

</div>
</div>
<a id="a7cc6dcb7afb68e81546966a1ec24d027"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7cc6dcb7afb68e81546966a1ec24d027">&#9670;&nbsp;</a></span>initInterrupts()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void RotaryEncoder::initInterrupts </td>
          <td>(</td>
          <td class="paramtype">void(*)()&#160;</td>
          <td class="paramname"><em>function</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the function to be called when a pin interrupt occurs. Ideally this wouldn't be needed and the pin interrupt would just call <a class="el" href="class_rotary_encoder.html#a5e2bc49ea9072d4932612ded0cfcfabf" title="Raises the button&#39;s _inputFlag. This should be wrapped in a function in the global scope and fed into...">RotaryEncoder::tick()</a>, but only static member functions can be used as callbacks for pin interrupts, so a wrapper function has to be written in the global scope and passed back into the button object. </p>

</div>
</div>
<a id="a3bd9303422d4287e96ea83c181f3fcd4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3bd9303422d4287e96ea83c181f3fcd4">&#9670;&nbsp;</a></span>setEventHandler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void RotaryEncoder::setEventHandler </td>
          <td>(</td>
          <td class="paramtype">void(*)(<a class="el" href="class_rotary_encoder.html">RotaryEncoder</a> *, uint8_t, int)&#160;</td>
          <td class="paramname"><em>function</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the function that is called any time an encoder event is detected. Some example callback functions can be found in the InputNode example. </p>

</div>
</div>
<a id="ac91df8b97b799e9411cda5eb4ba5de9c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac91df8b97b799e9411cda5eb4ba5de9c">&#9670;&nbsp;</a></span>setPosition()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void RotaryEncoder::setPosition </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets the encoder postion. Useful for resetting it back to zero for example. </p>

</div>
</div>
<a id="a5e2bc49ea9072d4932612ded0cfcfabf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e2bc49ea9072d4932612ded0cfcfabf">&#9670;&nbsp;</a></span>tick()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ICACHE_RAM_ATTR RotaryEncoder::tick </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Raises the button's _inputFlag. This should be wrapped in a function in the global scope and fed into <a class="el" href="class_rotary_encoder.html#a7cc6dcb7afb68e81546966a1ec24d027" title="Set the function to be called when a pin interrupt occurs. Ideally this wouldn&#39;t be needed and the pi...">RotaryEncoder::initInterrupts()</a> </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a492bcf97569c21fe3b050d5ee05f5240"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a492bcf97569c21fe3b050d5ee05f5240">&#9670;&nbsp;</a></span>kEventStableUpdate</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const uint8_t RotaryEncoder::kEventStableUpdate = 0</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Event ID for a stable update (potentiometer has been changed, then been stable longer than <code>_interval</code>). </p>

</div>
</div>
<a id="acca85bf302bd19eb2357518d6ce53569"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acca85bf302bd19eb2357518d6ce53569">&#9670;&nbsp;</a></span>kEventUnstableUpdate</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const uint8_t RotaryEncoder::kEventUnstableUpdate = 1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Event ID for a stable update (potentiometer has been changed, but not stopped moving yet). </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="_rotary_encoder_8h_source.html">RotaryEncoder.h</a></li>
</ul>
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
